#!/usr/bin/env bash
# Add RHI in firewall whitelist
MAC=$(dmesg | grep \'rndis_host\' | tail -n 1)
MAC_T=$(echo $MAC | rev | cut -d" " -f 1 | rev)
INTERFACE=$(echo $MAC | awk '{if ($1=="[") print $5;else print $4}' | sed  's/://')
for i in $( ls /sys/class/net )
do
  addr=$(cat /sys/class/net/$i/address)
  if [[ "$i" == "$INTERFACE" ]] || [[ "$MAC_T" == "$addr" ]]
  then
    echo "'rndis_host' interface: "$i
    tmp=$(grep 'FW_DEV_INT=' /etc/sysconfig/SuSEfirewall2)
    if [ ! -z "$tmp" ]
    then
      if echo "${tmp}" | grep -qP "(?<=\"|\s)${i}(?=\"|\s)" ;
      then
        echo "Redfish_HI is already in firewall whitelist"
        exit 0
      fi
	    tmp2=$(echo ${tmp} | sed 's/.$//')
      sed -i "s/${tmp}/${tmp2} ${i}\\\"/" /etc/sysconfig/SuSEfirewall2
      echo "Add Redfish_HI in firewall whitelist."
    else
      echo "Create new firewall config: /etc/sysconfig/SuSEfirewall2"
      echo "FW_DEV_INT=\"${i}\"" >> /etc/sysconfig/SuSEfirewall2
      echo "Add Redfish_HI in firewall whitelist."
    fi
    break
  fi
done
systemctl restart SuSEfirewall2
